Merge branch 'rg/gitweb'
[git/dscho.git] / t / test-lib.sh
blobe331cadcff479a8d9de59590c44b0502653653f9
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano
6 # Keep the original TERM for say_color
7 ORIGINAL_TERM=$TERM
9 # For repeatability, reset the environment to known value.
10 LANG=C
11 LC_ALL=C
12 PAGER=cat
13 TZ=UTC
14 TERM=dumb
15 export LANG LC_ALL PAGER TERM TZ
16 EDITOR=:
17 VISUAL=:
18 unset GIT_EDITOR
19 unset AUTHOR_DATE
20 unset AUTHOR_EMAIL
21 unset AUTHOR_NAME
22 unset COMMIT_AUTHOR_EMAIL
23 unset COMMIT_AUTHOR_NAME
24 unset EMAIL
25 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
26 unset GIT_AUTHOR_DATE
27 GIT_AUTHOR_EMAIL=author@example.com
28 GIT_AUTHOR_NAME='A U Thor'
29 unset GIT_COMMITTER_DATE
30 GIT_COMMITTER_EMAIL=committer@example.com
31 GIT_COMMITTER_NAME='C O Mitter'
32 unset GIT_DIFF_OPTS
33 unset GIT_DIR
34 unset GIT_WORK_TREE
35 unset GIT_EXTERNAL_DIFF
36 unset GIT_INDEX_FILE
37 unset GIT_OBJECT_DIRECTORY
38 unset SHA1_FILE_DIRECTORIES
39 unset SHA1_FILE_DIRECTORY
40 GIT_MERGE_VERBOSITY=5
41 export GIT_MERGE_VERBOSITY
42 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
43 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
44 export EDITOR VISUAL
45 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
47 # Protect ourselves from common misconfiguration to export
48 # CDPATH into the environment
49 unset CDPATH
51 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
52 1|2|true)
53 echo "* warning: Some tests will not work if GIT_TRACE" \
54 "is set as to trace on STDERR ! *"
55 echo "* warning: Please set GIT_TRACE to something" \
56 "other than 1, 2 or true ! *"
58 esac
60 # Each test should start with something like this, after copyright notices:
62 # test_description='Description of this test...
63 # This test checks if command xyzzy does the right thing...
64 # '
65 # . ./test-lib.sh
66 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
67 TERM=$ORIGINAL_TERM &&
68 export TERM &&
69 [ -t 1 ] &&
70 tput bold >/dev/null 2>&1 &&
71 tput setaf 1 >/dev/null 2>&1 &&
72 tput sgr0 >/dev/null 2>&1
73 ) &&
74 color=t
76 while test "$#" -ne 0
78 case "$1" in
79 -d|--d|--de|--deb|--debu|--debug)
80 debug=t; shift ;;
81 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
82 immediate=t; shift ;;
83 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
84 export GIT_TEST_LONG=t; shift ;;
85 -h|--h|--he|--hel|--help)
86 help=t; shift ;;
87 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
88 verbose=t; shift ;;
89 -q|--q|--qu|--qui|--quie|--quiet)
90 quiet=t; shift ;;
91 --no-color)
92 color=; shift ;;
93 --no-python)
94 # noop now...
95 shift ;;
97 break ;;
98 esac
99 done
101 if test -n "$color"; then
102 say_color () {
104 TERM=$ORIGINAL_TERM
105 export TERM
106 case "$1" in
107 error) tput bold; tput setaf 1;; # bold red
108 skip) tput bold; tput setaf 2;; # bold green
109 pass) tput setaf 2;; # green
110 info) tput setaf 3;; # brown
111 *) test -n "$quiet" && return;;
112 esac
113 shift
114 echo "* $*"
115 tput sgr0
118 else
119 say_color() {
120 test -z "$1" && test -n "$quiet" && return
121 shift
122 echo "* $*"
126 error () {
127 say_color error "error: $*"
128 trap - exit
129 exit 1
132 say () {
133 say_color info "$*"
136 test "${test_description}" != "" ||
137 error "Test script did not set test_description."
139 if test "$help" = "t"
140 then
141 echo "$test_description"
142 exit 0
145 exec 5>&1
146 if test "$verbose" = "t"
147 then
148 exec 4>&2 3>&1
149 else
150 exec 4>/dev/null 3>/dev/null
153 test_failure=0
154 test_count=0
155 test_fixed=0
156 test_broken=0
158 die () {
159 echo >&5 "FATAL: Unexpected exit with code $?"
160 exit 1
163 trap 'die' exit
165 # The semantics of the editor variables are that of invoking
166 # sh -c "$EDITOR \"$@\"" files ...
168 # If our trash directory contains shell metacharacters, they will be
169 # interpreted if we just set $EDITOR directly, so do a little dance with
170 # environment variables to work around this.
172 # In particular, quoting isn't enough, as the path may contain the same quote
173 # that we're using.
174 test_set_editor () {
175 FAKE_EDITOR="$1"
176 export FAKE_EDITOR
177 VISUAL='"$FAKE_EDITOR"'
178 export VISUAL
181 test_tick () {
182 if test -z "${test_tick+set}"
183 then
184 test_tick=1112911993
185 else
186 test_tick=$(($test_tick + 60))
188 GIT_COMMITTER_DATE="$test_tick -0700"
189 GIT_AUTHOR_DATE="$test_tick -0700"
190 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
193 # You are not expected to call test_ok_ and test_failure_ directly, use
194 # the text_expect_* functions instead.
196 test_ok_ () {
197 test_count=$(expr "$test_count" + 1)
198 say_color "" " ok $test_count: $@"
201 test_failure_ () {
202 test_count=$(expr "$test_count" + 1)
203 test_failure=$(expr "$test_failure" + 1);
204 say_color error "FAIL $test_count: $1"
205 shift
206 echo "$@" | sed -e 's/^/ /'
207 test "$immediate" = "" || { trap - exit; exit 1; }
210 test_known_broken_ok_ () {
211 test_count=$(expr "$test_count" + 1)
212 test_fixed=$(($test_fixed+1))
213 say_color "" " FIXED $test_count: $@"
216 test_known_broken_failure_ () {
217 test_count=$(expr "$test_count" + 1)
218 test_broken=$(($test_broken+1))
219 say_color skip " still broken $test_count: $@"
222 test_debug () {
223 test "$debug" = "" || eval "$1"
226 test_run_ () {
227 eval >&3 2>&4 "$1"
228 eval_ret="$?"
229 return 0
232 test_skip () {
233 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
234 this_test="$this_test.$(expr "$test_count" + 1)"
235 to_skip=
236 for skp in $GIT_SKIP_TESTS
238 case "$this_test" in
239 $skp)
240 to_skip=t
241 esac
242 done
243 case "$to_skip" in
245 say_color skip >&3 "skipping test: $@"
246 test_count=$(expr "$test_count" + 1)
247 say_color skip "skip $test_count: $1"
248 : true
251 false
253 esac
256 test_expect_failure () {
257 test "$#" = 2 ||
258 error "bug in the test script: not 2 parameters to test-expect-failure"
259 if ! test_skip "$@"
260 then
261 say >&3 "checking known breakage: $2"
262 test_run_ "$2"
263 if [ "$?" = 0 -a "$eval_ret" = 0 ]
264 then
265 test_known_broken_ok_ "$1"
266 else
267 test_known_broken_failure_ "$1"
270 echo >&3 ""
273 test_expect_success () {
274 test "$#" = 2 ||
275 error "bug in the test script: not 2 parameters to test-expect-success"
276 if ! test_skip "$@"
277 then
278 say >&3 "expecting success: $2"
279 test_run_ "$2"
280 if [ "$?" = 0 -a "$eval_ret" = 0 ]
281 then
282 test_ok_ "$1"
283 else
284 test_failure_ "$@"
287 echo >&3 ""
290 test_expect_code () {
291 test "$#" = 3 ||
292 error "bug in the test script: not 3 parameters to test-expect-code"
293 if ! test_skip "$@"
294 then
295 say >&3 "expecting exit code $1: $3"
296 test_run_ "$3"
297 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
298 then
299 test_ok_ "$2"
300 else
301 test_failure_ "$@"
304 echo >&3 ""
307 # This is not among top-level (test_expect_success | test_expect_failure)
308 # but is a prefix that can be used in the test script, like:
310 # test_expect_success 'complain and die' '
311 # do something &&
312 # do something else &&
313 # test_must_fail git checkout ../outerspace
316 # Writing this as "! git checkout ../outerspace" is wrong, because
317 # the failure could be due to a segv. We want a controlled failure.
319 test_must_fail () {
320 "$@"
321 test $? -gt 0 -a $? -le 129
324 # test_cmp is a helper function to compare actual and expected output.
325 # You can use it like:
327 # test_expect_success 'foo works' '
328 # echo expected >expected &&
329 # foo >actual &&
330 # test_cmp expected actual
333 # This could be written as either "cmp" or "diff -u", but:
334 # - cmp's output is not nearly as easy to read as diff -u
335 # - not all diff versions understand "-u"
337 test_cmp() {
338 $GIT_TEST_CMP "$@"
341 # Most tests can use the created repository, but some may need to create more.
342 # Usage: test_create_repo <directory>
343 test_create_repo () {
344 test "$#" = 1 ||
345 error "bug in the test script: not 1 parameter to test-create-repo"
346 owd=`pwd`
347 repo="$1"
348 mkdir "$repo"
349 cd "$repo" || error "Cannot setup test environment"
350 "$GIT_EXEC_PATH/git" init "--template=$GIT_EXEC_PATH/templates/blt/" >/dev/null 2>&1 ||
351 error "cannot run git init -- have you built things yet?"
352 mv .git/hooks .git/hooks-disabled
353 cd "$owd"
356 test_done () {
357 trap - exit
359 if test "$test_fixed" != 0
360 then
361 say_color pass "fixed $test_fixed known breakage(s)"
363 if test "$test_broken" != 0
364 then
365 say_color error "still have $test_broken known breakage(s)"
366 msg="remaining $(($test_count-$test_broken)) test(s)"
367 else
368 msg="$test_count test(s)"
370 case "$test_failure" in
372 # We could:
373 # cd .. && rm -fr 'trash directory'
374 # but that means we forbid any tests that use their own
375 # subdirectory from calling test_done without coming back
376 # to where they started from.
377 # The Makefile provided will clean this test area so
378 # we will leave things as they are.
380 say_color pass "passed all $msg"
381 exit 0 ;;
384 say_color error "failed $test_failure among $msg"
385 exit 1 ;;
387 esac
390 # Test the binaries we have just built. The tests are kept in
391 # t/ subdirectory and are run in 'trash directory' subdirectory.
392 PATH=$(pwd)/..:$PATH
393 GIT_EXEC_PATH=$(pwd)/..
394 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
395 unset GIT_CONFIG
396 unset GIT_CONFIG_LOCAL
397 GIT_CONFIG_NOSYSTEM=1
398 GIT_CONFIG_NOGLOBAL=1
399 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
401 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
402 export GITPERLLIB
403 test -d ../templates/blt || {
404 error "You haven't built things yet, have you?"
407 if ! test -x ../test-chmtime; then
408 echo >&2 'You need to build test-chmtime:'
409 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
410 exit 1
413 . ../GIT-BUILD-OPTIONS
415 # Test repository
416 test="trash directory"
417 rm -fr "$test" || {
418 trap - exit
419 echo >&5 "FATAL: Cannot prepare test area"
420 exit 1
423 test_create_repo "$test"
424 # Use -P to resolve symlinks in our working directory so that the cwd
425 # in subprocesses like git equals our $PWD (for pathname comparisons).
426 cd -P "$test" || exit 1
428 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
429 for skp in $GIT_SKIP_TESTS
431 to_skip=
432 for skp in $GIT_SKIP_TESTS
434 case "$this_test" in
435 $skp)
436 to_skip=t
437 esac
438 done
439 case "$to_skip" in
441 say_color skip >&3 "skipping test $this_test altogether"
442 say_color skip "skip all tests in $this_test"
443 test_done
444 esac
445 done